<?php

namespace EscapeWork\Manager\Medias\Providers;

use EscapeWork\Manager\Medias\Models\Media;
use EscapeWork\Manager\Medias\Observers\MediaObserver;
use Illuminate\Support\ServiceProvider;

class EventServiceProvider extends ServiceProvider
{

    public function boot()
    {
        Media::observe(new MediaObserver);
    }

    public function register()
    {
        $this->app['events']->listen('eloquent.deleted:*', function($model) {
            $destroyer = $this->app->make('EscapeWork\Manager\Medias\Services\MediasDestroyerService');

            // medias table
            foreach (config('manager-medias.medias.tables') as $config) {
                if (get_class($model) === $config['model']) {
                    $destroyer->removeFromMedias($model);
                    return;
                }
            }

            // model medias
            foreach (config('manager-medias.models') as $config) {
                if (get_class($model) === $config['model']) {
                    $destroyer->removeFromModel($model, $config);
                    return;
                }
            }
        });
    }
}
